﻿using System;
using System.Windows.Forms;
using ElmoMotionControl.GMAS.EASComponents.MMCLibDotNET;


namespace GMAS_Lib_test
{
    public partial class ErrorCorrectionControl : UserControl, IParentPanel
    {
        public ErrorCorrectionControl()
        {
            InitializeComponent();
        }
        
        private MMCErrorCorr errorCorr;
        private System.Windows.Forms.Panel panel;
        ConnectivityData connectData;
        public ConnectivityData ConnectData
        {
            get
            {
                return connectData;
            }
            set
            {
                connectData = value;
            }
        }

        public System.Windows.Forms.Panel GetPanel()
        {
            return panel;
        }
        public void Init(ConnectivityData data, System.Windows.Forms.Panel pnl)
        {
            ConnectData = data;
            panel = pnl;
            ConnectData.OnDataChange += new ConnectivityData.DataChange(ConnectData_OnDataChange);
            

        }

        void ConnectData_OnDataChange()
        {
            if (ConnectData.IsValid == false )
                EnableButtons(false);
            else
            {
                EnableButtons(true);
                //cmbTransMode.SelectedItem = ConnectData.GroupAxis.TransitionMode;
            }
        }

        private void EnableButtons(bool enable)
        {
            
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            errorCorr = new MMCErrorCorr( ConnectData.Handle );
            return;
        }

        private void button1_Click(object sender, EventArgs e)
        {
           errorCorr = new MMCErrorCorr(ConnectData.Handle);
            string filepath = tbFileName.Text;
            ErrorCorrTable corrTable = ErrorCorrTable.CreateErrorCorrTable(
                0,NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A,filepath);
            try
            {
                errorCorr.LoadErrorCorrTable(corrTable);
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                return;
            }
        }

        private void btnEnable_Click(object sender, EventArgs e)
        {
            if (errorCorr != null)
            {
                errorCorr.EnableErrorCorrTable(NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A);
            }
        }

        private void btnDisable_Click(object sender, EventArgs e)
        {
            if (errorCorr != null)
            {
                errorCorr.DisableErrorCorrTable(NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A);
            }
        }

        private void btnUnload_Click(object sender, EventArgs e)
        {
            if (errorCorr != null)
            {
                errorCorr.UnloadErrorCorrTable(NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A);
            }
        }

        private void btnStatus_Click(object sender, EventArgs e)
        {
            if (errorCorr == null)
            {
                errorCorr = new MMCErrorCorr(ConnectData.Handle);
            }
            try
            {
                NC_ERROR_TABLE_NUMBER num;
                switch (upDownTableNum.SelectedItem as string)
                {
                    case "A":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A;
                        break;
                    case "B":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_B;
                        break;
                    case "C":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_C;
                        break;
                    case "D":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_D;
                        break;
                    case "E":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_E;
                        break;
                    case "F":
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_F;
                        break;
                    default:
                        num = NC_ERROR_TABLE_NUMBER.NC_ERROR_TABLE_A;
                        break;
                }
                byte isEnabled;
                byte isLoaded;
                string fileName;
                int error = errorCorr.GetErrorTableStatus(num, out isEnabled, out isLoaded, out fileName);
                MessageBox.Show(string.Format("Error {0} ; Enabled {1} ; Loaded {2} ; File {3}",
                                              error, isEnabled, isLoaded, fileName));
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.Message + "\n MMC: " + ex.MMCError.ToString());
                return;
            }
        }
    }
}
