﻿using System;
using System.Windows.Forms;
using ElmoMotionControl.GMAS.EASComponents.MMCLibDotNET;

namespace GMAS_Lib_test
{
    public enum LocalHMethodsEnum
    {
        HM1 = 1,
        HM2 = 2,
        HM3 = 3,
        HM4 = 4,
        HM5 = 5,
        HM6 = 6,
        HM7 = 7,
        HM8 = 8,
        HM9 = 9,
        HM10 = 10,
        HM11 = 11,
        HM12 = 12,
        HM13 = 13,
        HM14 = 14,
        HM15 = 15,
        HM16 = 16,
        HM17 = 17,
        HM18 = 18,
        HM19 = 19,
        HM20 = 20,
        HM21 = 21,
        HM22 = 22,
        HM23 = 23,
        HM24 = 24,
        HM25 = 25,
        HM26 = 26,
        HM27 = 27,
        HM28 = 28,
        HM29 = 29,
        HM30 = 30,
        HM31 = 31,
        HM32 = 32,
        HM33 = 33,
        HM34 = 34,
        HM35 = 35,
        HM36 = 36,
        
    }
    public partial class Homing402Control : UserControl, IParentPanel
    {
        public Homing402Control()
        {
            InitializeComponent();
        }
        private System.Windows.Forms.Panel panel;
        public Panel GetPanel()
        {
            return panel;
        }
        ConnectivityData connectData;
        public ConnectivityData ConnectData
        {
            get
            {
                return connectData;
            }
            set
            {
                connectData = value;
            }
        }
        public void Init(ConnectivityData data, System.Windows.Forms.Panel pnl)
        {
            ConnectData = data;
            panel = pnl;
            ConnectData.OnDataChange += new ConnectivityData.DataChange(ConnectData_OnDataChange);
            ConnectData_OnDataChange();
        }
        void ConnectData_OnDataChange()
        {
            if (ConnectData.IsValid == false || ConnectData.SingleAxis == null)
                EnableButtons(false);
            else
                EnableButtons(true);

        }
        private void EnableButtons(bool enable)
        {
            btnPowerOn.Enabled = enable;
            btnPowerOff.Enabled = enable;
            //btnStop.Enabled = enable;
            btnHome402.Enabled = enable;
            btnSetMode.Enabled = enable;
        }

        private bool MotionPreview()
        {
            MC_STATE_SINGLE state = 0;
            uint plcStateMask = 0x7F8;//0x3F8;//0x7;//0x00000400
            uint validBitMask = 0x40000000;//0x3F8;//0x7;//0x00000400

            UInt32 rv = 0;

            try
            {
                rv = ConnectData.SingleAxis.ReadStatus();
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                EnableButtons(false);
                MessageBox.Show("Please disconnect and reboot device", "Internal Communication Error");
                ConnectData.Default();
                return false;
            }

            if ((rv & validBitMask) == validBitMask)
            {
                state = (MC_STATE_SINGLE)(rv & plcStateMask);
            }

            if ((state & MC_STATE_SINGLE.ERROR_STOP) == MC_STATE_SINGLE.ERROR_STOP)
            {
                try
                {
                    ConnectData.SingleAxis.Reset();
                }
                catch (MMCException ex)
                {
                    MessageBox.Show(ex.ToString(), "MMC Exception");
                    EnableButtons(false);
                    MessageBox.Show("Please disconnect and reboot device", "Internal Communication Error");
                    ConnectData.Default();
                    return false;
                }
            }

            try
            {
                rv = ConnectData.SingleAxis.ReadStatus();
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                EnableButtons(false);
                MessageBox.Show("Please disconnect and reboot device", "Internal Communication Error");
                ConnectData.Default();
                return false;
            }
            if ((rv & validBitMask) == validBitMask)
            {
                state = (MC_STATE_SINGLE)(rv & plcStateMask);
            }
            else
            {
                MessageBox.Show("Illegal state recognized .Possible Reason - GMAS is in Preoperational mode.",
                                "Homing402 Control");
                //ConnectData.Default();
                return false;
            }

            return true;
        }

        private void btnHome402_Click(object sender, EventArgs e)
        {
            if (!MotionPreview())
                return;
            MMC_HOMEDS402Params hParam = new MMC_HOMEDS402Params();

            if (tbHPos.Text == null || tbHPos.Text == string.Empty)
                hParam.dbPosition = ConnectData.SingleAxis.HomePosition;
            else
            {
                if (!Double.TryParse(tbHPos.Text, out hParam.dbPosition))
                    MessageBox.Show("Position Value Error", "Argument Error");
            }
            hParam.eBufferMode = (MC_BUFFERED_MODE_ENUM)cmbBuffMode.SelectedItem;
            hParam.uiHomingMethod = (UInt16)(LocalHMethodsEnum)cmbHomeMethod.SelectedItem;
            

            if (tbAcc.Text == null || tbAcc.Text == string.Empty)
                hParam.fAcceleration = (float) ConnectData.SingleAxis.HomeAcceleration;
            else
            {
                if (!Single.TryParse(tbAcc.Text, out hParam.fAcceleration))
                    MessageBox.Show("Acceleration Value Error", "Argument Error");
            }

            if (tbDistanceLimit.Text == null || tbDistanceLimit.Text == string.Empty)
                hParam.fDistanceLimit = (float) ConnectData.SingleAxis.HomeDistanceLimit;
            else
            {
                if (!Single.TryParse(tbDistanceLimit.Text, out hParam.fAcceleration))
                    MessageBox.Show("Distance Value Error", "Argument Error");
            }

            if (tbTimeLimit.Text == null || tbTimeLimit.Text == string.Empty)
                hParam.uiTimeLimit = ConnectData.SingleAxis.HomeTimeLimit;
            else
            {
                if (!UInt32.TryParse(tbTimeLimit.Text, out hParam.uiTimeLimit))
                    MessageBox.Show("Time Limit Value Error", "Argument Error");
            }

            if (tbTorqLimit.Text == null || tbTorqLimit.Text == string.Empty)
                hParam.fTorqueLimit = (float) ConnectData.SingleAxis.HomeTorqueLimit;
            else
            {
                if (!Single.TryParse(tbTorqLimit.Text, out hParam.fTorqueLimit))
                    MessageBox.Show("Torque Limit Value Error", "Argument Error");
            }

            if (tbVelocity.Text == null || tbVelocity.Text == string.Empty)
                hParam.fVelocity = (float) ConnectData.SingleAxis.HomeVelocity;
            else
            {
                if (!Single.TryParse(tbVelocity.Text, out hParam.fVelocity))
                    MessageBox.Show("Velocity Limit Value Error", "Argument Error");
            }
            hParam.ucExecute = 1;
            try
            {
                ConnectData.SingleAxis.HomeDS402(hParam);
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                return;
            }
            String res = "Homing command successfully Accepted.";
            ConnectData.ToOutput(res);
        }

        private void btnSetMode_Click(object sender, EventArgs e)
        {
            OPM402 opMode = ConnectData.SingleAxis.GetOpMode();
            if (opMode != OPM402.OPM402_HOMING_MODE)
            {
                try
                {
                    ConnectData.SingleAxis.SetOpMode(OPM402.OPM402_HOMING_MODE);
                }
                catch (MMCException ex)
                {
                    MessageBox.Show(ex.ToString(), "Homing Control");
                }
                String res = "Operated Mode successfully changed to " + OPM402.OPM402_HOMING_MODE.ToString();
                ConnectData.ToOutput(res);
                return;
            }
            String rs = "Operated Mode already equal to " + OPM402.OPM402_HOMING_MODE.ToString();
            ConnectData.ToOutput(rs);
        }

        private void btnPowerOn_Click(object sender, EventArgs e)
        {
            try
            {
                ConnectData.SingleAxis.PowerOn(MC_BUFFERED_MODE_ENUM.MC_BUFFERED_MODE);
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                return;
            }
            String res = "PowerOn command successfully completed.";
            ConnectData.ToOutput(res);
        }

        private void btnPowerOff_Click(object sender, EventArgs e)
        {
            try
            {
                try
                {
                    ConnectData.SingleAxis.PowerOff(MC_BUFFERED_MODE_ENUM.MC_BUFFERED_MODE);
                }
                catch (MMCException ex)
                {
                    MessageBox.Show(ex.ToString(), "MMC Exception");
                    return;
                }
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                return;
            }
            String res = "PowerOff command successfully completed.";
            ConnectData.ToOutput(res);
        }

        private void InitValues()
        {
            Array arOPM = Enum.GetValues(typeof(MC_BUFFERED_MODE_ENUM));
            foreach (object obj in arOPM)
                cmbBuffMode.Items.Add(obj);
            cmbBuffMode.SelectedIndex = 2;

            Array arDir = Enum.GetValues(typeof(LocalHMethodsEnum));
            foreach (object obj in arDir)
                cmbHomeMethod.Items.Add(obj);
            cmbHomeMethod.SelectedItem = LocalHMethodsEnum.HM34;
            if (ConnectData == null || ConnectData.SingleAxis == null)
                return;
            tbAcc.Text = ConnectData.SingleAxis.Acceleration.ToString();
            tbDistanceLimit.Text = ConnectData.SingleAxis.HomeDistanceLimit.ToString();
            tbHPos.Text = ConnectData.SingleAxis.HomePosition.ToString();
            tbTimeLimit.Text = ConnectData.SingleAxis.HomeTimeLimit.ToString();
            tbTorqLimit.Text = ConnectData.SingleAxis.HomeTorqueLimit.ToString();
            tbVelocity.Text = ConnectData.SingleAxis.HomeVelocity.ToString();
        }
        private void OnLoad(object sender, EventArgs e)
        {
            Visible = true;
            Dock = DockStyle.Fill;
            InitValues();
            
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            if (!MotionPreview())
                return;
            try
            {
                ConnectData.SingleAxis.Stop(MC_BUFFERED_MODE_ENUM.MC_BUFFERED_MODE);
            }
            catch (MMCException ex)
            {
                MessageBox.Show(ex.ToString(), "MMC Exception");
                return;
            }
            String res = "Stop command successfully Accepted.";
            ConnectData.ToOutput(res);
        }

        private void OnVisibleChange(object sender, EventArgs e)
        {
            if (Visible == false)
            {
                if (ConnectData != null && ConnectData.IsValid && ConnectData.SingleAxis != null)
                {
                    try
                    {
                        ConnectData.SingleAxis.PowerOff(MC_BUFFERED_MODE_ENUM.MC_BUFFERED_MODE);
                    }
                    catch (MMCException ex)
                    {
                        MessageBox.Show(ex.ToString(), "MMC Exception");
                        return;
                    }
                }
            }
        }
    }
}
